require 'nokogiri'
require 'open-uri'
require 'openssl'

class Scraper
  attr_accessor :source, :name

  def initialize(source, name)
    @source = source
    @name = name
    @AppRoot = File.join(Dir.pwd, name)
  end

  def open(*args)
    super *args, allow_redirections: :safe, ssl_verify_mode: OpenSSL::SSL::VERIFY_NONE
  end

  def scrap
    system 'mkdir', '-p', @AppRoot
    scraproot =  @AppRoot
    system 'mkdir', '-p', scraproot + "/img"
    system 'mkdir', '-p', scraproot + "/js"
    system 'mkdir', '-p', scraproot + "/css"

    page = Nokogiri::HTML(open(@source))

    e = /^.*\.(jpg|JPG|gif|GIF|png|PNG|tiff|tif|TIFF|TIF)/

    n=0
    page.xpath('//img/@data-src', '//img/@src').each do |img|
      # asset_name = '/img/' + n.to_s + File.basename(img.value, ".*") + "." +
      #   e.match(File.extname(img.value)).to_a.last.to_s
      asset_name = img.value
      filename = scraproot + asset_name
      system 'mkdir', '-p', File.dirname(filename)

	open(filename , 'wb') do |file|
    puts "Writing #{filename}"
        file << open(URI.join( @source, img.value ).to_s).read
        img.content = asset_name
	end
	 n += 1
    end

    n=0
    page.xpath('//link/@href').each do |link|
      asset_name = '/css/' + n.to_s + ".css"
      filename = scraproot + asset_name
      open(filename, 'wb') do |file|
        puts "Writing #{filename}"
        begin
          open(URI.join( @source, link.value ).to_s).read
          rescue
          else
            file << open(URI.join( @source, link.value ).to_s).read
       end
        link.content = asset_name
      end
      n = n + 1
    end

    n=0
    page.xpath('//script/@src').each do |script|
      asset_name = '/js/' + n.to_s + File.basename(script.value)
      filename = scraproot + asset_name
      open(filename, 'wb') do |file|
        puts "Writing #{filename}"
        file << open(URI.join( @source, script.value ).to_s).read
        script.content = asset_name
      end
    n = n + 1
    end
    open(scraproot + "/" + "index.html", "wb") do |file|
      puts "Writing #{scraproot + "/" + "index.html"}"
      file.write(page)
    end
  end
end

#####
# Patch to allow open-uri to follow safe (http to https)
# and unsafe redirections (https to http).
#
# Original gist URL:
# https://gist.github.com/1271420
#
# Relevant issue:
# http://redmine.ruby-lang.org/issues/3719
#
# Source here:
# https://github.com/ruby/ruby/blob/trunk/lib/open-uri.rb
#
# Thread-safe implementation adapted from:
# https://github.com/obfusk/open_uri_w_redirect_to_https
#
module OpenURI
  class <<self
    alias_method :open_uri_original, :open_uri
    alias_method :redirectable_cautious?, :redirectable?

    def redirectable?(uri1, uri2)
      case Thread.current[:__open_uri_redirections__]
      when :safe
        redirectable_safe? uri1, uri2
      when :all
        redirectable_all? uri1, uri2
      else
        redirectable_cautious? uri1, uri2
      end
    end

    def redirectable_safe?(uri1, uri2)
      redirectable_cautious?(uri1, uri2) || http_to_https?(uri1, uri2)
    end

    def redirectable_all?(uri1, uri2)
      redirectable_safe?(uri1, uri2) || https_to_http?(uri1, uri2)
    end
  end

  #####
  # Patches the original open_uri method, so that it accepts the
  # :allow_redirections argument with these options:
  #
  #   * :safe will allow HTTP => HTTPS redirections.
  #   * :all  will allow HTTP => HTTPS and HTTPS => HTTP redirections.
  #
  # OpenURI::open can receive different kinds of arguments, like a string for
  # the mode or an integer for the permissions, and then a hash with options
  # like UserAgent, etc.
  #
  # To find the :allow_redirections option, we look for this options hash.
  #
  def self.open_uri(name, *rest, &block)
    Thread.current[:__open_uri_redirections__] = allow_redirections(rest)

    block2 = lambda do |io|
      Thread.current[:__open_uri_redirections__] = nil
      block[io]
    end

    begin
      open_uri_original name, *rest, &(block ? block2 : nil)
    ensure
      Thread.current[:__open_uri_redirections__] = nil
    end
  end

  private

  def self.allow_redirections(args)
    options = first_hash_argument(args)
    options.delete :allow_redirections if options
  end

  def self.first_hash_argument(arguments)
    arguments.select { |arg| arg.is_a? Hash }.first
  end

  def self.http_to_https?(uri1, uri2)
    schemes_from([uri1, uri2]) == %w(http https)
  end

  def self.https_to_http?(uri1, uri2)
    schemes_from([uri1, uri2]) == %w(https http)
  end

  def self.schemes_from(uris)
    uris.map { |u| u.scheme.downcase }
  end
end
