module Permutation
  class API
    DEFAULT_HOST = "http://app.permutation.io"

    class Response
      def initialize(status, body)
        @status = status
        @body   = body
      end

      attr_reader :status
      def body
        @parsed_body ||= JSON.parse @body, symbolize_names: false
      end
    end

    class << self
      def get(url, headers={})
        conn = Faraday.new(:url => host) do
          faraday.response :logger if ENV['DEBUG']  # log requests to STDOUT
        end
        conn.headers = headers
        response = conn.get url
        # puts response.body
        Response.new(response.status, response.body)
      end

      def post(url, params={}, headers={})
        conn = Faraday.new(:url => host) do |faraday|
          faraday.request  :url_encoded             # form-encode POST params
          faraday.response :logger if ENV['DEBUG']  # log requests to STDOUT
          faraday.adapter  Faraday.default_adapter  # make requests with Net::HTTP
        end

        conn.headers = headers

        response = conn.post url, params
        Response.new(response.status, response.body)
      end

      def host
        @host = ENV['HOST'] ||
                Permutation::Config.host ||
                DEFAULT_HOST
      end
    end
  end
end
